/*--------------------------------------------------------------------
  display module.

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#include	"ed.h"


void	disp_clrflag() // ....
{
	dispall.ff=TRUE;
}

dispfmt_t	*disp_fmtinit(const char *s, dispfmt_t *dfp)
{
	dispfmt_t *dfpb;

	dfpb=malloc(sizeof(dispfmt_t));
	if (dfpb==NULL)
		error("mem error:disp_fmtinit");

	if (dfp!=NULL)
		dfp->next=dfpb;

	col_normal(&dfpb->col);
	dfpb->str=malloc(strlen(s)+1);
	if (dfpb->str==NULL)
		error("mem error:disp_fmtinit");
	strcpy(dfpb->str, s);
	dfpb->next=NULL;

	return dfpb;
}

void	disp_fmtsfin(dispfmt_t *dfp)
{
	dispfmt_t	*next;

//fprintf(stderr,"disp_fmtsfin %p\n",dfp);

	while(dfp!=NULL)
		{
		 next=dfp->next;
		 free(dfp->str);
		 free(dfp);
		 dfp=next;
		}
}

/*
void	df_debug(dispfmt_t *dfp)
{
	while(dfp!=NULL)
		{
		 fprintf(stderr,"[%s] %02x\n",dfp->str,dfp->col);
		 dfp=dfp->next;
		}
	fprintf(stderr,"\n");
}
*/

void	disp_regresize(dispreg_t *drp,int sizex,int sizey)
{
	int 	i,a;

	if (sizex> dispall.sizex)
		sizex= dispall.sizex;
	if (sizey> dispall.sizey)
		sizey= dispall.sizey;

	if (sizex!=-1)
		drp->sizex=sizex;

	if (sizey!=-1|| drp->sizey!= sizey)
		{
		 if (drp->sizey >sizey)
		 	{
		 	 dispall.ff=TRUE;
		 	 for (i=sizey;i<drp->sizey;++i)
		 	 	{
		 	 	 disp_fmtsfin(drp->l_dfp[i]);
		 	 	 drp->l_dfp[i]=NULL;
		 	 	}
		 	}

		 drp->sizey= sizey;

		 a=drp->y+ sizey -dispall.sizey;
		 if (a>0)
		 	 drp->y-=a;
		}
}


void	disp_regview(dispreg_t *drp,bool ff)
{
	dispfmt_t	*dfp,*l_dfp,*b_dfp;
	bool		sf;
	char		*p,*q;
	int 		n,m,a,b,i;

	char		spc_buf[LN_dispbuf+1];


	if (drp->ff)
		{
		 drp->ff=FALSE;
		 ff=TRUE;
		}

	sf=TRUE;

	for (i=0;i<drp->sizey;++i)
		{
//fprintf(stderr,"**\n");

		 dfp=drp->func(drp->vp, i, drp->sizex, drp->sizey);
		 if (dfp==NULL)
		 	continue;
		 b_dfp=dfp;


		 l_dfp=drp->l_dfp[i];
		 if (l_dfp==NULL)
		 	ff=TRUE; else
		 	q=l_dfp->str;
		 p=dfp->str;
		 n=drp->sizex;
		 m=0;

		 memset(spc_buf, ' ', n);
		 spc_buf[n]='\0';


		 for (;;)
		 	{
		 	 if (*p=='\0')
		 	 	{
//fprintf(stderr," *%p\n", dfp->next);
		 	 	 if (dfp->next==NULL)
		 	 	 	p=spc_buf; else
		 	 	 	{
		 	 	 	 dfp=dfp->next;
		 	 	 	 p=dfp->str;
		 	 	 	}
		 	 	}
//fprintf(stderr,"*>[%s]\n",p);

		 	 if (ff)
		 	 	a= min(strlen(p),n-m); else
		 	 	{
		 	 	 if (*q=='\0')
		 	 	 	{
		 	 	 	 if (l_dfp->next==NULL)
		 	 	 	 	{
		 	 	 	 	 q=spc_buf;
		 	 	 	 	 if (p==q)
		 	 	 	 	 	break;
		 	 	 	 	}else
		 	 	 	 	{
		 	 	 	 	 l_dfp=l_dfp->next;
		 	 	 	 	 q=l_dfp->str;
		 	 	 	 	}
		 	 	 	}
//fprintf(stderr,"*<[%s]\n",q);

		 	 	 if (!col_cmp(l_dfp->col, dfp->col))
		 	 	 	a=min(min(strlen(p),strlen(q)), n-m); else
		 	 	 	{
		 	 	 	 /* while(*p!='\0'&& *p==*q&& m<n)
		 	 	 	 	++p,++q,++m; */

		 	 	 	 a=0;
		 	 	 	 while(p[a]!='\0'&& p[a]==q[a]&& a<n-m)
		 	 	 	 	++a;
		 	 	 	 if (sf|| a>=7)
		 	 	 	 	{
		 	 	 	 	 p+=a;
		 	 	 	 	 q+=a;
		 	 	 	 	 m+=a;
		 	 	 	 	 a=0;
		 	 	 	 	}
		 	 	 	 b=a;

		 	 	 	 while(p[a]!='\0'&& q[a]!='\0'&& p[a]!=q[a]&& a<n-m)
		 	 	 	 	++a;

		 	 	 	 if (b==a&& a>0)
		 	 	 	 	{
		 	 	 	 	 p+=a;
		 	 	 	 	 q+=a;
		 	 	 	 	 m+=a;
		 	 	 	 	 a=0;
		 	 	 	 	}
		 	 	 	}
		 	 	 q+=a;
		 	 	}

		 	 if (a>0)
		 	 	{
//if (!ff)
//fprintf(stderr,"  %2d/%2d:%2d[%*.*s] %02x\n", m, n, a, a ,a, p, dfp->col);
		 	 	 term_color(dfp->col);
		 	 	 term_locate(drp->y+i, drp->x +m);
		 	 	 widthputs(p,a);

		 	 	 m+=a;
		 	 	 p+=a;

		 	 	 sf=FALSE;
		 	 	}

//fprintf(stderr,"---\n");

		 	 if (m>=n)
		 	 	break;
		 	}

		 if (drp->l_dfp[i]!=NULL)
		 	disp_fmtsfin(drp->l_dfp[i]);
		 drp->l_dfp[i]=b_dfp;
		}
//fprintf(stderr,"-\n");
}

dispreg_t	*disp_reginit()
{
	dispreg_t	*drp;

	drp=(dispreg_t *)malloc(sizeof(dispreg_t));
	drp->x=0;
	drp->y=0;
	drp->sizex=dispall.sizex;
	drp->sizey=dispall.sizey;
	drp->vp=NULL;

	drp->l_dfp=(dispfmt_t **)malloc(sizeof(dispfmt_t *)*dispall.sizey);
	memset(drp->l_dfp, 0, sizeof(dispfmt_t *)*dispall.sizey);

// fprintf(stderr,"reg_ini %p\n",drp);

	return drp;
}

int 	disp_regexist(dispreg_t *drp)
{
	int 	i;

//	if (drp==NULL)
//		return -1;

	for (i=0;i<dispall.drp_num;++i)
		{
		 if (drp== dispall.drp[i])
		 	return i;
		}

	return -1;
}

void	disp_regadd(dispreg_t *drp)
{
// fprintf(stderr,"reg_add %p\n",drp);
	if (dispall.drp_num>=MAX_dispreg || disp_regexist(drp)!=-1)
		return;

	drp->ff=TRUE;
	dispall.drp[dispall.drp_num]=drp;
	++dispall.drp_num;
}


void	disp_regrm(dispreg_t *drp)
{
	int 	i;

// fprintf(stderr,"reg_rm %p\n",drp);

	i=disp_regexist(drp);
	if (i==-1)
		return;


	if (i+1<dispall.drp_num)
		memcpy(&dispall.drp[i], &dispall.drp[i+1]
							, sizeof(dispreg_t *) * dispall.drp_num-i-1);
	--dispall.drp_num;
}

void	disp_regfin(dispreg_t *drp)
{
	int 	i;

// fprintf(stderr,"reg_fin\n",drp);

	disp_regrm(drp);

	for (i=0;i<drp->sizey;++i)
		disp_fmtsfin(drp->l_dfp[i]);

	free(drp->l_dfp);
	free(drp);
}


void	disp_allinit()
{
	dispall.drp_num=0;
	dispall.sizex= GetMaxCol();
	dispall.sizey= GetMaxRow()+1;	//!!
	dispall.ff=TRUE;

}

void	disp_allview()
{
	int 	i;


// fprintf(stderr,"!%d\n", dispall.drp_num);

	for (i=0;i<dispall.drp_num;++i)
		{
//fprintf(stderr,"* %p ",dispall.drp[i]);
		 disp_regview(dispall.drp[i], dispall.ff);
		}
//fprintf(stderr,"*\n",dispall.drp[i]);

	if (dispall.ff)
		dispall.ff=FALSE;
}

