/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:nxedit.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#define	VAL_impl

#include "ed.h"
#include "sh.h"
#include <ctype.h>

void	ef_init()
{
	int 	i;

	for (i = FILE_START; i < MAXEDIT; i++)
		{
		 *ef[i].path='\0';

		 ef[i].pm=FALSE;
		 *ef[i].ss='\0';
		 *ef[i].rs='\0';
		}

	for (CurrentFileNo= UNDO_SYSTEM
			; CurrentFileNo< FILE_START; CurrentFileNo++)
		FileStartInit(FALSE);
}


void	opening()
{
	int length;
	int put;
	char *title1 = "        Multi FILE Editor      ";
	char *title2 = "               Ne              ";
	char *copyright = "Copyright (c) 1991, 1992 I.Nebashi";

/* ɽ򤤤롣 */

	length = strlen(copyright);
	put = GetColWidth()/2-length/2-2;

	term_cls();
	term_color_normal();

	term_locate(GetRowWidth()/2-4, put);
		term_printf("%-*.*s", GetColWidth()-4, GetColWidth()-4, title1);
	term_locate(GetRowWidth()/2-2, put);
		term_printf("%-*.*s", GetColWidth()-4, GetColWidth()-4, title2);
	term_locate(GetRowWidth()/2+2, put);
		term_printf("%-*.*s", GetColWidth()-4, GetColWidth()-4, copyright);

	term_locate(GetMaxRow(), GetMinCol());
	term_flush();
}




/*-------------------------------------------------------------------
	Main Command Loop
-------------------------------------------------------------------*/

void	ne_loop(int region)
{
	void	(*p)(void);

 	int 	key;

	for (;;) 
		{
		 if (region==0)
		 	{
		 	 if (csrse.uf
		 	 		|| csrle.l_sx!=GetScroll()
		 	 		|| csrse.l_sy!=csr_getsy()
		 	 		|| (GetBlockFlg() && csrse.l_cy!=GetRow()))
		 	 	CrtDrawAll();
		 	 if (sysinfo.sl_drp!=NULL)
		 	 	sysinfo.sl_drp->ff=TRUE;
		 	}

		 disp_allview();
		 key=get_keyf(region);
		 RefreshMessage();

		 if (region==0&& csrse.gf)
		 	{
		 	 csrse.gf=FALSE;
		 	 crt_crmark();
		 	}

		 if (key==-1)
		 	continue;

		 if ((key&KF_normalcode)!=0)
		 	{
		 	 if (region==0)
		 	 	InputAndCrt(key& ~KF_normalcode); 
		 	} else
		 	{
		 	 p=funclist[0][key];
		 	 p();
		 	}
		}
}

void	ne_fin()
{
	exit(0);
}


void	sysinfo_path(char *s,const char *t)
{
	sprintf(s, "%s/%s", sysinfo.nxpath, t);
}

void	sysinfo_init()
{
	char	*p;

	sysinfo.vp_def=gval_init(NULL, MAX_val);
	opt_default();

	p=getenv("HOME");
	if (p!=NULL)
		strcpy(sysinfo.nxpath, p); else
		getcwd(sysinfo.nxpath, LN_path);
	strcat(sysinfo.nxpath, "/.ne");
	mkdir(sysinfo.nxpath, 0777); // !!

	sysinfo.shell=getenv("SHELL");
	if (sysinfo.shell==NULL)
		sysinfo.shell="/bin/sh";

	config_read(".nerc");
}

bool	ne_arg(int argc,char *argv[])
{
	int 	line;
	int 	optcount;
	bool	pf;
	char	buf[LN_dispbuf+1];
	bool	f;
	int 	c;
	char	*sp,*p;

	line=0;
	f=FALSE;
	pf=FALSE;

	for (optcount=1; optcount<argc; ++optcount) // ????
		{
		 c=getopt(argc, argv, "rjeod:D:");
		 if (c==EOF)
		 	break;

		 switch(c) 
		 	{
		  case 'j':
		  	 gval_set(sysinfo.vp_def, "japanese","true");
		  	 break;
		  case 'e':
		  	 gval_set(sysinfo.vp_def, "japanese","false");
		  	 break;
		  case 'r':
		  	 pf=TRUE;
		  	 break;
		  case 'o':
		  	 opening();
		  	 break;
		  case 'D':
		  	 strcpy(buf,optarg);
		  	 optcount++;
		  	 sp=buf;
		  	 p=strsep(&sp,"=");
		  	 gval_set(sysinfo.vp_def, buf, p);
		 	}
		}

	sysinfo_optset();


	if (pf)
		return profile_read();

	for (; optcount<argc; ++optcount)
		{
		 if (*argv[optcount]=='+')
		 	line=atoi(argv[optcount]+1); else
		 	{
		 	 if (FileOpenOp(argv[optcount]))
		 	 	f=TRUE;
		 	}
		}

	if (!f&& line>0)
		{
		 int	a;

		 a=min(line,GetRowWidth()/2+1);

		 csr_setly(line-a+1);
		 csr_setdy(a);
		}

	if (!f)
		FileOpenOp("untitled.txt");

	return f;
}

int 	main(int argc,char *argv[])
{
	bool	f;

	term_init();
	term_start(TM_init| TM_tinit| TM_keypad| TM_ansicolor);

	disp_allinit();
	SetSignal();

	lists_init();
	ef_init();

	keydef_init();
	sysinfo_init();
	f=ne_arg(argc, argv);
	key_set();


	udbuf_init();
	bbuf_init();
	search_init();
	eff_init(NULL,NULL);
	system_guide_init();
	*sysinfo.doublekey='\0'; // !!
	csrse.uf=TRUE;

	ne_loop(0);
}



/*-------------------------------------------------------------------
	Escape Shell
-------------------------------------------------------------------*/
void	CommandCom(char *sys_buff)
{
	bool	f;

	term_stop();

	if (*sys_buff == '\0')
		{
		 puts(TYPE_EXIT_MSG);
		 system(sysinfo.shell);
		 f=FALSE;
		} else 
		{
		 puts(sys_buff);
		 system(sys_buff);
		 f=TRUE;
		}

	term_start(TM_init| TM_tinit| TM_keypad| TM_ansicolor);
/*
	if (f)
		{
		 printf("%s",HIT_ANY_KEY_MSG);
		 fflush(stdout);
		 inkey_wait(NULL);
		}
*/

	csrse.uf=TRUE;
	disp_clrflag();
}

void	op_misc_exec()
{
	char	buf[MAXEDITLINE+1];

	*buf='\0';
	if (HisGets(buf, GETS_SHELL_MSG, SHELLS_SYSTEM) != NULL)
		CommandCom(buf);
}

void	error(const char *s)
{
	HearderrEnd(s);
}



void	op_opt_linenum()
{
	opt_set("number", NULL);

//	OffsetSetByColum();
	csrse.uf=TRUE;
}

void	op_misc_redraw()
{
	term_cls();
	csrse.uf=TRUE;
	disp_clrflag();
}


