/*--------------------------------------------------------------------
  new string search and replace module.

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#include	"ed.h"
#include	<regexp.h>
#include	<ctype.h>



void	cursor_move(int lx,long ly)	// !!
{
	RefreshMessage();

	csr_setly(ly);
	csr_setlx(lx);
}





// multi search/replaceѥХåե
	char	m_ss[MAXEDITLINE+1];	/* search strings */
	char	m_rs[MAXEDITLINE+1];	/* replace strings */

//
	char	g_ss[MAXEDITLINE+1];	/* ʸХåե */

void	search_init()
{
	*m_ss='\0';
	*m_rs='\0';

	*g_ss='\0';
}

SHELL	void	op_search_getword()
{
	int 	lx;

	if (*g_ss=='\0')
		lx=csrle.lx; else
		lx=csrle.lx+strlen(g_ss);

	lx=kanji_tknext(csrle.buf,lx,FALSE)-csrle.lx;
	if (lx==0)
		return;

	strncpy(g_ss,csrle.buf+csrle.lx, lx);
	g_ss[lx]='\0';

	system_msg(g_ss);

	ef[CurrentFileNo].pm=TRUE;
	strcpy(ef[CurrentFileNo].ss,g_ss);
}

void	search_clrword()
{
	*g_ss='\0';
}


void	strtoupper(char *s,const char *t)
{
	if (!sysinfo.nocasef)
		{
		 strcpy(s,t);
		 return ;
		}

	while(*t!='\0')
		{
		 *s++=toupper(*t);
		 ++t;
		}
	*s='\0';
}

long	search_next(const char *s,int x,long y,regm_t *rmp)
{
	EditLine	*ed;
	long	n;
	char	buf_a[MAXEDITLINE+1],buf_b[MAXEDITLINE+1];

	strtoupper(buf_a,s);

	n=GetLastNumber();

	ed=GetList(y);
	for (;y<=n;++y)
		{
		 strtoupper(buf_b,ed->buffer);
		 if (regexp_seeknext(buf_b,buf_a,x,rmp))	//buffer
		 	return y;
		 ed=ed->next;
		 if (ed==NULL)
		 	break;
		 x=0;
		}
	return -1;
}

long	search_prev(const char *s,int x,long y,regm_t *rmp)
{
	EditLine	*ed;
	char	buf_a[MAXEDITLINE+1],buf_b[MAXEDITLINE+1];

	strtoupper(buf_a,s);

	ed=GetList(y);
	for (;y>0;--y)
		{
		 strtoupper(buf_b,ed->buffer);
		 if (regexp_seekprev(buf_b,buf_a,x,rmp))	//buffer
		 	return y;
		 ed=ed->prev;
		 if (ed==NULL||ed->buffer==NULL)			//buffer
		 	break;
		 x=strlen(ed->buffer);						//buffer
		}
	return -1;
}

SHELL	void	op_search_in()
{
	char	buf[MAXEDITLINE+1];

	crt_ledraw();
	*buf='\0';
	if (HisGets(buf,GETS_FIND_MSG,SEARCHS_SYSTEM)==NULL 
			|| *buf=='\0')
		{
		 ef[CurrentFileNo].pm=FALSE;
		 *ef[CurrentFileNo].ss='\0';
		}else
		{
		 lm_mark(GetLineOffset(), 0);
		 ef[CurrentFileNo].pm=TRUE;
		 strcpy(ef[CurrentFileNo].ss,buf);
		}

	system_guide();
	crt_ledraw();
}

SHELL	void	op_search_prev()
{
	regm_t	rm;
	long	y;

	if (*ef[CurrentFileNo].ss=='\0')
		{
		 op_search_in();
		 if (*ef[CurrentFileNo].ss=='\0')
		 	return;
		}

	csr_leupdate();
	system_msg(SEARCHING_MSG);
	y=search_prev(ef[CurrentFileNo].ss, 
					GetBufferOffset()-1, GetLineOffset(), &rm);
	crt_ledraw();

	if (y==-1)
		system_msg(NOT_FOUND_MSG); else
		cursor_move(rm.rm_so,y);
}

SHELL	void	op_search_next()
{
	regm_t	rm;
	long	y;

	if (*ef[CurrentFileNo].ss=='\0')
		{
		 op_search_in();
		 if (*ef[CurrentFileNo].ss=='\0')
		 	return;
		}

	csr_leupdate();
	system_msg(SEARCHING_MSG);
	y=search_next(ef[CurrentFileNo].ss, 
					GetBufferOffset()+1, GetLineOffset(), &rm);
	crt_ledraw();

	if (y==-1)
		system_msg(NOT_FOUND_MSG); else
		cursor_move(rm.rm_so,y);
}

void	replace()
{
	regm_t	rm;
	long	y,my;
	int 	x,mx;
	int 	chgNo;
	char	buf[MAXLINESTR+1];
	bool	rf;

	int 	cx,sx,lx,cy;
	long	ly;


	csr_leupdate();

	cx=csrle.cx;
	sx=csrle.sx;
	lx=csrle.lx;
	cy=csrse.cy;
	ly=csrse.ly;

	chgNo=0;
	mx=0;
	my=0;
	switch(ef[CurrentFileNo].replm)
		{
	 case REPLM_before:
	 	 mx=lx;
	 	 my=ly;
	 case REPLM_all:
	 default:
	 	 x=1;
	 	 y=1;
	 	 break;
	 case REPLM_after:
	 	 x=lx;
	 	 y=ly;
	 	 break;
	 case REPLM_block:
		 x=1;
		 y=GetBlockStart();
		 my=GetBlockEnd();
		}

	rf=FALSE;
	for (;;)
		{
		 system_msg(SEARCHING_MSG);
		 y=search_next(ef[CurrentFileNo].ss, x, y, &rm);

		 if (y==-1)
		 	break;

		 x=rm.rm_so;
		 if (my!=0&& (y>my|| (y==my&& mx!=0&& x>mx)))
		 	break;

		 cursor_move(x,y);

		 if (!rf)
		 	{
		 	 char	c;

		 	 csrse.uf=TRUE;
		 	 CrtDrawAll();
		 	 term_locate(GetRow(), GetCol()+NumWidth);

		 	 term_color_normal();
		 	 term_color(sysinfo.c_search);
		 	 term_puts(ef[CurrentFileNo].ss);	// !!ɽб롣

		 	 c=keysel("ִޤ? (Y/N/A) :","Yy\r\nNnAa \x1b");
		 	 if (c=='\x1b')
		 	 	break;
		 	 if (c=='n'||c==' ')
		 	 	{
		 	 	 ++x;
		 	 	 continue;
		 	 	}
		 	 if (c=='a')
		 	 	rf=TRUE;
		 	}

		 se_delete(rm.rm_eo-x,FALSE);
		 se_insert(ef[CurrentFileNo].rs,FALSE);
		 x+=strlen(ef[CurrentFileNo].rs);

		 csr_leupdate();

		 ++chgNo;
		}
// Ѵ򳫻ϤΥ֤᤹
	csrle.cx=cx;
	csrle.sx=sx;
	csrle.lx=lx;
	csrse.cy=cy;
	csrse.ly=ly;
	csr_fix();
	csr_lenew();

	sprintf(buf, "[ %.30s -> %-.30s ] %d %s..."
		, ef[CurrentFileNo].ss, ef[CurrentFileNo].rs, chgNo, REPLACED_MSG);
	system_msg(buf);

	csrse.uf=TRUE;
}




SHELL	void	op_search_paging()
{
	ef[CurrentFileNo].pm= ef[CurrentFileNo].pm?FALSE:TRUE;
	system_guide();
}

SHELL	void	op_search_repl_redo()
{
	if (*m_ss=='\0'||*m_rs=='\0')
		return;
	strcpy(ef[CurrentFileNo].ss,m_ss);
	strcpy(ef[CurrentFileNo].rs,m_rs);
	ef[CurrentFileNo].replm=REPLM_all;
	replace();
}

SHELL	void	op_search_repl()
{
	int 	res;
	int 	nums;

	csr_leupdate();
	crt_ledraw();

	nums=block_ismode()?4:3;
	res=menu_vselect(GetCol(), GetRow(), nums, REPLACE_ALL_MSG
		, REPLACE_FORWARD_MSG, REPLACE_BACK_MSG, REPLACE_INSIDEBLOCK_MSG);

	switch(res) {
	case -1:
		csrse.uf=TRUE;
		return;
	case 0:
		ef[CurrentFileNo].replm=REPLM_all;
		break;
	case 1:
		ef[CurrentFileNo].replm=REPLM_after;
		break;
	case 2:
		ef[CurrentFileNo].replm=REPLM_before;
		break;
	case 3:
		ef[CurrentFileNo].replm=REPLM_block;
		break;
	}

	csrse.uf=TRUE;
	CrtDrawAll();
	*ef[CurrentFileNo].ss='\0';
	if (HisGets(ef[CurrentFileNo].ss, GETS_FIND_MSG, SEARCHS_SYSTEM) == NULL) 
		{
		 crt_ledraw();
		 return;
		}
	*ef[CurrentFileNo].rs='\0';
	if (HisGets(ef[CurrentFileNo].rs, GETS_REPLACE_MSG, SEARCHS_SYSTEM) == NULL) 
		{
		 crt_ledraw();
		 return;
		}

	strcpy(m_ss,ef[CurrentFileNo].ss);
	strcpy(m_rs,ef[CurrentFileNo].rs);
	replace();
	crt_ledraw();
}

