/*--------------------------------------------------------------------
  Terminal Module.
    based on NxEdit2.04    ::term.h
             FD clone 1.03g::term.h

    Copyright (C) 1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#ifndef	__TERM_H_
#define	__TERM_H_


#define	TM_keypad		1
#define	TM_init			2
#define	TM_tinit		4
#define	TM_ansicolor	8

extern	void	term_init();
extern	void	term_start(int mode);
extern	void	term_stop();
extern	int 	term_getmode();
extern	void	term_setmode(int mode);

extern	void	term_flush(); 		/* ɽեå */
extern	void	term_kflush();		/* ϥեå */

extern	int 	term_kbhit(u_long usec);
extern	int 	term_getch();
extern	int 	term_dputc(int c);


extern	void	term_insln();
extern	void	term_delln();
extern	void	term_bell();
extern	void	term_csrf();
extern	void	term_csrn();
extern	void	term_csrh();

extern	void	term_cls();
extern	void	term_clrtoe();


extern	void	term_locate(int y,int x);
extern	void	term_movex(int x);

extern	int 	term_puts(char *s);
extern	int 	term_putch(int c);
extern	int 	term_printf(const char *fmt,...);

extern	int 	term_inkey();
extern	void	keys_set(const char *k, const char *e, const char *d);


typedef	struct
{
	uint	fc:3;	/* ʿ */
	uint	bc:3;	/* طʿ */
	uint	rf:1;	/* ȿž   */
	uint	uf:1;	/*    */
	uint	bf:1;	/*    */
}	color_t;

#define	AC_black	0
#define	AC_red		1
#define	AC_green	2
#define	AC_yellow	3
#define	AC_blue		4
#define	AC_magenta	5
#define	AC_cyan		6
#define	AC_white	7

extern	color_t	term_cftocol(const char *s);
extern	bool	col_cmp(color_t cola,color_t colb);

extern	void	term_color(color_t c);
extern	void	term_color_normal();
extern	void	term_color_fc(int fc);
extern	void	term_color_underline();
extern	void	term_color_reverse();
extern	void	term_color_bold();


#endif	/* __TERM_H_ */
